import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'course' },
})
export class Course extends BaseModel {
  @prop({ required: false, index: true, zh: '年度' })
  year: string;
  @prop({ required: false, index: true, zh: '标题' })
  title: string;
  @prop({ required: false, index: true, zh: '类型' })
  type: string;
  @prop({ required: false, index: true, zh: '课程类型' })
  brand: string;
  @prop({ required: false, index: false, zh: '封面' })
  logo: Array<any>;
  @prop({ required: false, index: false, zh: '总学时' })
  hour: string;
  @prop({ required: false, index: false, zh: '发布时间' })
  time: string;
  @prop({ required: false, index: false, zh: '简介' })
  brief: string;
  @prop({ required: false, index: false, zh: '内容' })
  content: string;
  @prop({ required: false, index: true, zh: '浏览量', default: 0 })
  number: number;
  @prop({ required: false, index: true, zh: '是否使用', default: '0' })
  is_use: string;
  @prop({ required: false, index: true, zh: '状态', default: '0' })
  status: string;
}
