import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_video {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '课程id' })
  'course': string = undefined;
  @ApiProperty({ description: '标题' })
  'title': string = undefined;
  @ApiProperty({ description: '简介' })
  'brief': string = undefined;
  @ApiProperty({ description: '视频来源' })
  'sourse': string = undefined;
  @ApiProperty({ description: '类型' })
  'type': string = undefined;
  @ApiProperty({ description: '封面' })
  'logo': Array<any> = undefined;
  @ApiProperty({ description: '视频' })
  'file': Array<any> = undefined;
  @ApiProperty({ description: '学时' })
  'hour': string = undefined;
  @ApiProperty({ description: '播放次数' })
  'number': number = undefined;
  @ApiProperty({ description: '内容' })
  'content': string = undefined;
  @ApiProperty({ description: '发布时间' })
  'time': string = undefined;
  @ApiProperty({ description: '是否使用' })
  'is_use': string = undefined;
  @ApiProperty({ description: '状态' })
  'status': string = undefined;
}

export class QDTO_video extends SearchBase {
  constructor() {
    const like_prop = ['title'];
    const props = ['course', 'type', 'title', 'time', 'number', 'is_use'];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '课程id' })
  'course': string = undefined;
  @ApiProperty({ description: '标题' })
  'title': string = undefined;
  @ApiProperty({ description: '类型' })
  'type': string = undefined;
  @ApiProperty({ description: '发布时间' })
  'time': string = undefined;
  @ApiProperty({ description: '播放次数' })
  'number': number = undefined;
  @ApiProperty({ description: '是否使用' })
  'is_use': string = undefined;
}

export class QVO_video extends FVO_video {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_video {
  @ApiProperty({ description: '课程id' })
  @Rule(RuleType['string']().empty(''))
  'course': string = undefined;
  @ApiProperty({ description: '标题' })
  @Rule(RuleType['string']().empty(''))
  'title': string = undefined;
  @ApiProperty({ description: '简介' })
  @Rule(RuleType['string']().empty(''))
  'brief': string = undefined;
  @ApiProperty({ description: '视频来源' })
  @Rule(RuleType['string']().empty(''))
  'sourse': string = undefined;
  @ApiProperty({ description: '发布时间' })
  @Rule(RuleType['string']().empty(''))
  'time': string = undefined;
  @ApiProperty({ description: '类型' })
  @Rule(RuleType['string']().empty(''))
  'type': string = undefined;
  @ApiProperty({ description: '封面' })
  @Rule(RuleType['array']().empty(''))
  'logo': Array<any> = undefined;
  @ApiProperty({ description: '视频' })
  @Rule(RuleType['array']().empty(''))
  'file': Array<any> = undefined;
  @ApiProperty({ description: '学时' })
  @Rule(RuleType['string']().empty(''))
  'hour': string = undefined;
  @ApiProperty({ description: '播放次数' })
  @Rule(RuleType['number']().empty(''))
  'number': number = undefined;
  @ApiProperty({ description: '内容' })
  @Rule(RuleType['string']().empty(''))
  'content': string = undefined;
  @ApiProperty({ description: '是否使用' })
  @Rule(RuleType['string']().empty(''))
  'is_use': string = undefined;
  @ApiProperty({ description: '状态' })
  @Rule(RuleType['string']().empty(''))
  'status': string = undefined;
}

export class CVO_video extends FVO_video {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_video extends CDTO_video {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_video extends FVO_video {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
