import { Provide } from '@midwayjs/decorator';
import { InjectEntityModel } from '@midwayjs/typegoose';
import { ReturnModelType } from '@typegoose/typegoose';
import { BaseService } from 'free-midway-component';
import { New } from '../../entity/core/new.entity';
type modelType = ReturnModelType<typeof New>;
@Provide()
export class NewService extends BaseService<modelType> {
  @InjectEntityModel(New)
  model: modelType;

  async queryTotal(filter) {
    const { is_use, status } = filter;
    const total0 = await this.model.count({ is_use, status });
    const total1 = await this.model.count({ is_use, status, type: '0' });
    const total2 = await this.model.count({ is_use, status, type: '1' });
    const total3 = await this.model.count({ is_use, status, type: '2' });
    const list = [
      { title: '全部', total: total0 },
      { title: '国家级', total: total1 },
      { title: '省级', total: total2 },
      { title: '其他', total: total3 },
    ];
    return list;
  }
}
